' DeNUL.VBS V1.02 (C) yoshioka.teruo@nifty.com 2005-11-26
' DeNUL.VBS removes NUL and irregular CR and converts irregular LF to CR+LF.
' Usage: [Start] DeNUL[.VBS] files...
' Usage: CScript.EXE //NoLogo path\DeNUL.VBS {files...|<input >output}

Option Explicit

Const adTypeBinary=1
Const adTypeText=2

Dim fso
Dim fCScript
Dim arg
Dim fo
Dim iPath
Dim iName
Dim baseName
Dim extName
Dim dirName
Dim oName
Dim oPath
Dim BOM
Dim fUNICODE
Dim fCONVERTED,NULs,CRs,LFs
Dim k
Dim fName

Set fso=CreateObject("Scripting.FileSystemObject")
fCScript=(LCase(fso.GetBaseName(WScript.FullName))="cscript")

For Each arg In WScript.Arguments
  Set fo=fso.GetFile(arg)
  iPath=fo.Path
  iName=fo.Name
  baseName=fso.GetBaseName(iName)
  extName=fso.GetExtensionName(iName)
  dirName=fso.GetParentFolderName(iPath)
  oName=fso.GetTempName()
  oPath=fso.BuildPath(dirName,oName)
  fUNICODE=False
  BOM=fso.OpenTextFile(iPath,,,False).Read(2)
  If Len(BOM)>1 Then
    If Asc(Mid(BOM,1,1))=&HFF And Asc(Mid(BOM,2,1))=&HFE Then fUNICODE=True
  End If
  If fUNICODE Then
    fCONVERTED=uConv(fso.OpenTextFile(iPath,,,True),fso.CreateTextFile(oPath,False,True))
  Else
    fCONVERTED=iConv(iPath,oPath)
  End If
  If fCONVERTED Then
    For k=1000 To 1999
      fName=baseName & "." & Right(k ,3)
      Call Rename(fo,fName)
      If Err=0 Then
        Exit For
      ElseIf Err<>58 Then
        WScript.Echo Err.Number & " : " & Err.Description
        WSscript.Quit
      End If
    Next
    WScript.Echo NULs & " NULs removed." & vbLf & CRs & " CRs removed. " & vbLf & LFs & " LFs converted." & vbLf _
               & "To" & vbTab & iName & vbLf _
               & "From" & vbTab & fName

    Set fo=fso.GetFile(oPath)
    Call Rename(fo,iName)
    If Err<>0  Then
      WScript.Echo Err.Number & ":" & Err.Description
      WScript.Quit
    End If
  Else
    fso.DeleteFile(oPath)
    WScript.Echo "Not Converted : " & iName
  End If
Next
If WScript.Arguments.Count=0 Then
  If fCScript Then
    fCONVERTED=sConv(fso.GetStandardStream(0,True),fso.GetStandardStream(1,True))
    WScript.StdErr.WriteLine NULs & " NULs removed."
    WScript.StdErr.WriteLine CRs & " CRs removed. "
    WScript.StdErr.WriteLine LFs & " LFs converted."
  Else 
    WScript.Echo "Usage: Start DeNUL.VBS files..."
  End If
End If
WScript.Quit

Sub Rename(fo,fName)
On Error Resume Next
fo.Name=fName
End Sub

Function iConv(iPath,oPath)
Dim Src
Dim Dst
Dim buf
Dim k
Dim code,code2,code3
Dim Tmp
Dim CR

Set Tmp=CreateObject("ADODB.Stream")
Tmp.Open
Tmp.Type=adTypeText
Tmp.Charset="ascii"
Tmp.WriteText vbCr
Tmp.Position=0
Tmp.Type=adTypeBinary
CR=Tmp.Read(1)
Tmp.Close
Set Tmp=Nothing

NULs=0
CRs=0
LFs=0
Set Src=CreateObject("ADODB.Stream")
Src.Open
Src.Type=adTypeBinary
Src.LoadFromFile iPath
Set Dst=CreateObject("ADODB.Stream")
Dst.Open
Dst.Type=adTypeBinary
buf=Src.Read(-1)

For k=1 To LenB(buf)
  code=AscB(MidB(buf,k,1))
  If k<LenB(buf) Then code2=AscB(MidB(buf,k+1,1)) Else code2=-1
  If k>1 Then code3=AscB(MidB(buf,k-1,1)) Else code3=-1
  If code=0 Then
    NULs=NULs+1
  ElseIf code=13 And code2<>10 Then
    CRs=CRs+1
  ElseIf code=10 And code3<>13 Then
    LFs=LFs+1
    Dst.Write CR
    Src.Position=k-1
    Src.CopyTo Dst,1
  Else
    Src.Position=k-1
    Src.CopyTo Dst,1
  End If
Next
Src.Close
Dst.SaveToFile oPath
Dst.Close
Set Src=Nothing
Set Dst=Nothing
iConv=NULs+CRs+LFs
End Function

Function sConv(iFile,oFile)
Dim buf
Dim out
Dim k
Dim code,code2,code3

NULs=0
CRs=0
LFs=0
If iFile.AtEndOfStream Then Exit Function
buf=ReadAll(iFile)
out=""
For k=1 To LenB(buf)
  code=AscB(MidB(buf,k,1))
  If k<LenB(buf) Then code2=AscB(MidB(buf,k+1,1)) Else code2=-1
  If k>1 Then code3=AscB(MidB(buf,k-1,1)) Else code3=-1
  If code=0 Then
    NULs=NULs+1
  ElseIf code=13 And code2<>10 Then
    CRs=CRs+1
  ElseIf code=10 And code3<>13 Then
    LFs=LFs+1
    out=out & ChrB(13) & ChrB(code)
  Else
    out=out & ChrB(code)
  End If
Next

oFile.Write out
sConv=NULs+CRs+LFs
End Function

Function uConv(iFile,oFile)
Dim buf
Dim out
Dim k
Dim code,code2,code3

NULs=0
CRs=0
LFs=0
If iFile.AtEndOfStream Then Exit Function
buf=ReadAll(iFile)
out=""
For k=1 To Len(buf)
  code=Asc(Mid(buf,k,1))
  If k<Len(buf) Then code2=Asc(Mid(buf,k+1,1)) Else code2=-1
  If k>1 Then code3=Asc(Mid(buf,k-1,1)) Else code3=-1
  If code=0 Then
    NULs=NULs+1
  ElseIf code=13 And code2<>10 Then
    CRs=CRs+1
  ElseIf code=10 And code3<>13 Then
    LFs=LFs+1
    out=out & Chr(13) & Chr(code)
  Else
    out=out & Chr(code)
  End If
Next

oFile.Write out
uConv=NULs+CRs+LFs
End Function

Function ReadAll(file)
Dim block
Do While Not file.AtEndOfStream
block=block & file.Read(4096)
Loop
ReadAll=block
End Function
